/*
 * WS2812.h
 *
 *  Created on: Dec 20, 2023
 *      Author: hussamaldean
 */

#ifndef WS2812_H_
#define WS2812_H_

#include "stdint.h"

/*Set number of LED in the string*/
#define NUM_OF_LEDs 24

/*
 * @brief This function will set the LED Brightness.
 * @param brightness value.
 * @return nothing.
 * */
void WS2812_Set_Brightness(uint8_t value);

/*
 * @brief This function will set the LED colors value.
 * @param led: LED Number.
 * @param RED: Red color value.
 * @param GREEN: Green color value.
 * @param BLUE: Blue color value.
 * @retun nothing
 * */
void WS2812_Set_LED_Color (int led, int RED, int GREEN, int BLUE);

/*
 * @brief This function will write the data to the LED string.
 * @param nothing.
 * @return nothing
 * */
void WS2812_Set (void);



#endif /* WS2812_H_ */
