/*
 * WS2812.c
 *
 *  Created on: Dec 20, 2023
 *      Author: hussamaldean
 */

#include "WS2812.h"
#include "SPI1.h"
#include "delay.h"

uint8_t brightness=100;

uint8_t LED_Data[NUM_OF_LEDs][4];

void WS2812_Set_Brightness(uint8_t value)
{
	if(value>100)value=100;
	brightness=value;
}

void WS2812_Set_LED_Color (int led, int RED, int GREEN, int BLUE)
{
	LED_Data[led][0] = led;
	LED_Data[led][1] = GREEN;
	LED_Data[led][2] = RED;
	LED_Data[led][3] = BLUE;
}


static void ws2812_spi (int GREEN, int RED, int BLUE)
{

	GREEN = GREEN*brightness/100;
	RED = RED*brightness/100;
	BLUE = BLUE*brightness/100;

	uint32_t color = GREEN<<16 | RED<<8 | BLUE;
	uint8_t sendData[24];
	int indx = 0;

	for (int i=23; i>=0; i--)
	{
		if (((color>>i)&0x01) == 1) sendData[indx++] = 0b110;  // store 1
		else sendData[indx++] = 0b100;  // store 0
	}

	SPI1_Transmit( sendData, 24);
}

void WS2812_Set (void)
{
	for (int i=0; i<NUM_OF_LEDs; i++)
	{
		ws2812_spi(LED_Data[i][1], LED_Data[i][2], LED_Data[i][3]);
	}
	delay (1);
}
